=== modified file 'Makefile'
--- Makefile	2001-10-01 07:46:34 +0000
+++ Makefile	2004-07-28 15:43:18 +0000
@@ -55,7 +55,7 @@
 INCLUDE		=	-I.
 #INCLUDE	=
 #<<need getopt()>>
-LIBS		= $(PAM_LIBS)
+LIBS		= $(PAM_LIBS) $(SELINUX_LIBS)
 #<<optimize or debug?>>
 OPTIM		=	-O2
 #OPTIM		=	-g
@@ -74,12 +74,12 @@
 # Allow override from command line
 DEBUG_DEFS = -DDEBUGGING=0   
 # The -DUSE_SIGCHLD is needed for the Alpha port
-DEFS = -DDEBIAN -DUSE_SIGCHLD $(DEBUG_DEFS) $(PAM_DEFS)
+DEFS = -DDEBIAN -DUSE_SIGCHLD $(DEBUG_DEFS) $(PAM_DEFS) $(SELINUX_DEFS)
 #(SGI IRIX systems need this)
 #DEFS		=	-D_BSD_SIGNALS -Dconst=
 #<<the name of the BSD-like install program>>
 #INSTALL = installbsd
-INSTALL = install
+INSTALL = install -s
 #<<any special load flags>>
 # LDFLAGS		=	-s
 # Let install do the strip
@@ -118,8 +118,8 @@
 			$(CC) $(LDFLAGS) -o crontab $(CRONTAB_OBJ) $(LIBS)
 
 install		:	all
-			$(INSTALL) -c -m  755 -o root -s cron    $(DESTSBIN)/
-			$(INSTALL) -c -m 4755 -o root -s crontab $(DESTBIN)/
+			$(INSTALL) -c -m  755 -o root cron    $(DESTSBIN)/
+			$(INSTALL) -c -m 4755 -o root crontab $(DESTBIN)/
 			sh putman.sh crontab.1 $(DESTMAN)
 			sh putman.sh cron.8    $(DESTMAN)
 			sh putman.sh crontab.5 $(DESTMAN)

=== modified file 'compat.h'
--- compat.h	2001-10-01 07:46:34 +0000
+++ compat.h	2004-07-28 15:43:18 +0000
@@ -106,7 +106,7 @@
 # define NEED_GETDTABLESIZE
 #endif
 
-#if (BSD >= 199103)
+#if (BSD >= 199103) || defined(__linux)
 # define HAVE_SAVED_UIDS
 #endif
 

=== modified file 'config.h'
--- config.h	2001-10-01 07:46:34 +0000
+++ config.h	2004-07-28 15:43:18 +0000
@@ -43,7 +43,8 @@
 			 */
 
 #define MAILCMD _PATH_SENDMAIL					/*-*/
-#define MAILARGS "%s -i -FCronDaemon -odi -oem  %s"		/*-*/
+/* #define MAILARGS "%s -i -FCronDaemon -odi -oem  %s"		/*-*/
+#define MAILARGS "%s -i -FCronDaemon -oem  %s"		/*-*/
 			/* -i    = don't terminate on "." by itself
                          * -Fx	 = set full-name of sender
 			 * -odi	 = Option Deliverymode Interactive

=== modified file 'cron.8'
--- cron.8	2001-10-01 07:46:34 +0000
+++ cron.8	2004-07-28 15:43:18 +0000
@@ -23,10 +23,19 @@
 cron \- daemon to execute scheduled commands (Vixie Cron)
 .SH SYNOPSIS
 cron
+.RB [ -f ]
 .SH DESCRIPTION
 .I cron
 is started automatically from /etc/init.d on entering multi-user
 runlevels.
+.SH OPTIONS
+.TP 8
+.B -f
+Stay in foreground mode, don't daemonize.
+.TP
+.B -l
+Enable LSB compliant names for /etc/cron.d files
+.SH NOTES
 .PP
 .I cron
 searches its spool area (/var/spool/cron/crontabs) for crontab
@@ -39,11 +48,32 @@
 
 .I cron
 also reads /etc/crontab, which is in a slightly different format (see
-.IR crontab(5)). 
-Additionally, cron reads the files in /etc/cron.d; see
-the
-.B DEBIAN SPECIFIC
-section below for more details.
+.IR crontab(5) ). 
+Additionally,
+.I cron
+reads the files in /etc/cron.d: it
+treats the files in /etc/cron.d as extensions to the /etc/crontab file (they
+follow the special format of that file, i.e. they include the 
+.I user
+field). The intended purpose of this feature is to allow packages that require
+finer control of their scheduling than the /etc/cron.{daily,weekly,monthly} 
+directories allow to add a crontab file to /etc/cron.d. Such files
+should be named after the package that supplies them. Files must
+conform to the same naming convention as used by 
+.IR run-parts(8) :
+they
+must consist solely of upper- and lower-case letters, digits, underscores,
+and hyphens. If the 
+.B -l
+option is specified, then they must conform to the LSB namespace specification,
+exactly as in the
+.B --lsbsysinit
+option in 
+.IR run-parts .
+
+Like /etc/crontab, the files in the /etc/cron.d directory are
+monitored for changes. In general, the admin should not use /etc/cron.d/,
+but use the standard system crontab /etc/crontab.
 
 .I cron
 then wakes up every minute, examining all stored crontabs, checking
@@ -51,7 +81,7 @@
 executing commands, any output is mailed to the owner of the crontab
 (or to the user named in the MAILTO environment variable in the
 crontab, if such exists).  The children copies of cron running these
-processes has its name coerced to uppercase, as will be seen in the
+processes have their name coerced to uppercase, as will be seen in the
 syslog and ps output.
 .PP
 Additionally,
@@ -83,19 +113,10 @@
 .PP
 Clock changes of more than 3 hours are considered to be corrections to
 the clock, and the new time is used immediately.
-.SH DEBIAN SPECIFIC
+.PP
 .I cron
-treats the files in /etc/cron.d as extensions to the /etc/crontab file (they
-follow the special format of that file, i.e. they include the 
-.I user
-field). The intended purpose of this feature is to allow packages that require
-finer control of their scheduling than the /etc/cron.{daily,weekly,monthly} 
-directories allow to add a crontab file to /etc/cron.d. Such files
-should be named after the package that supplies them. Files must
-conform to the same naming convention as used by run-parts(8): they
-must consist solely of upper- and lower-case letters, digits, underscores,
-and hyphens. Like /etc/crontab, the files in the /etc/cron.d directory are
-monitored for changes.
+logs its action to the syslog facility 'cron', and logging may be
+controlled using the standard syslogd(8) facility.
 .SH "SEE ALSO"
 crontab(1), crontab(5)
 .SH AUTHOR

=== modified file 'cron.c'
--- cron.c	2001-10-01 07:46:34 +0000
+++ cron.c	2004-07-28 15:43:18 +0000
@@ -99,7 +99,7 @@
 	if (0) {
 # endif
 		(void) fprintf(stderr, "[%d] cron started\n", getpid());
-	} else {
+	} else if (!stay_foreground) {
 		switch (fork()) {
 		case -1:
 			log_it("CRON",getpid(),"DEATH","can't fork");
@@ -147,8 +147,6 @@
 		time_min timeDiff;
 		int wakeupKind;
 
-		load_database(&database);
-
 		/* ... wait for the time (in minutes) to change ... */
 		do {
 			cron_sleep(timeRunning + 1);
@@ -156,6 +154,8 @@
 		} while (clockTime == timeRunning);
 		timeRunning = clockTime;
 
+		load_database(&database);
+
 		/*
 		 * ... calculate how the current time differs from
 		 * our virtual clock. Classify the change into one
@@ -428,14 +428,23 @@
 {
 	int	argch;
 
-	while (EOF != (argch = getopt(argc, argv, "x:"))) {
+	stay_foreground = 0;
+        lsbsysinit_mode = 0;
+
+	while (EOF != (argch = getopt(argc, argv, "lfx:"))) {
 		switch (argch) {
 		default:
 			usage();
+		case 'f':
+			stay_foreground = 1;
+			break;
 		case 'x':
 			if (!set_debug_flags(optarg))
 				usage();
 			break;
+                case 'l':
+                    lsbsysinit_mode = 1;
+                    break;
 		}
 	}
 }

=== modified file 'cron.h'
--- cron.h	2001-10-01 07:46:34 +0000
+++ cron.h	2004-07-28 15:43:18 +0000
@@ -40,6 +40,13 @@
 #include "config.h"
 #include "externs.h"
 
+#ifdef WITH_SELINUX
+#include <selinux/selinux.h>
+#endif
+
+#define SYSUSERNAME "root"
+
+
 	/* these are really immutable, and are
 	 *   defined for symbolic convenience only
 	 * TRUE, FALSE, and ERR must be distinct
@@ -105,7 +112,7 @@
 
 #if DEBUGGING
 # define Debug(mask, message) \
-			if ( (DebugFlags & (mask) ) == (mask) ) \
+			if ( (DebugFlags & (mask) )  ) \
 				printf message;
 #else /* !DEBUGGING */
 # define Debug(mask, message) \
@@ -180,6 +187,9 @@
 	char		*name;
 	time_t		mtime;		/* last modtime of crontab */
 	entry		*crontab;	/* this person's crontab */
+#ifdef WITH_SELINUX
+        security_context_t scontext;    /* SELinux security context */
+#endif
 } user;
 
 typedef	struct _cron_db {
@@ -230,7 +240,7 @@
 		**env_copy __P((char **)),
 		**env_set __P((char **, char *));
 
-user		*load_user __P((int, struct passwd *, char *)),
+user		*load_user __P((int, struct passwd *, char *, char *, char *)),
 		*find_user __P((cron_db *, char *));
 
 entry		*load_entry __P((FILE *, void (*)(),
@@ -270,6 +280,9 @@
 time_min virtualTime;
 time_min clockTime;
 
+int	stay_foreground;
+int     lsbsysinit_mode;
+
 # if DEBUGGING
 int	DebugFlags;
 char	*DebugFlagNames[] = {	/* sync with #defines */
@@ -282,6 +295,7 @@
 		*MonthNames[],
 		*DowNames[],
 		*ProgramName;
+extern  int     lsbsysinit_mode;
 extern	int	LineNumber;
 extern	time_t	StartTime;
 extern  time_min timeRunning;

=== modified file 'crontab.1'
--- crontab.1	2001-10-01 07:46:34 +0000
+++ crontab.1	2004-07-28 15:43:18 +0000
@@ -82,12 +82,10 @@
 .I -e
 option is used to edit the current crontab using the editor specified by
 the \s-1VISUAL\s+1 or \s-1EDITOR\s+1 environment variables.
-The specified editor
-.B must
-edit the file in place;
-any editor that unlinks the file and recreates it cannot be used.
 After you exit
-from the editor, the modified crontab will be installed automatically.
+from the editor, the modified crontab will be installed automatically. If
+neither of the environment variables is defined, then the
+default editor /usr/bin/editor is used.
 .SH DEBIAN SPECIFIC
 The "out-of-the-box" behaviour for
 .I crontab -l

=== modified file 'crontab.5'
--- crontab.5	2001-10-01 07:46:34 +0000
+++ crontab.5	2004-07-28 15:43:18 +0000
@@ -52,7 +52,15 @@
 The
 .I value
 string may be placed in quotes (single or double, but matching) to preserve
-leading or trailing blanks.
+leading or trailing blanks. The  
+.I value
+string is 
+.B not
+parsed for environmental substitutions, thus lines like
+.PP
+    PATH = $HOME/bin:$PATH
+.PP
+will not work as you might expect.
 .PP
 Several environment variables are set up
 automatically by the
@@ -61,7 +69,7 @@
 SHELL is set to /bin/sh, and LOGNAME and HOME are set from the /etc/passwd 
 line of the crontab's owner. PATH is set to "/usr/bin:/bin".
 HOME, SHELL, and PATH may be overridden by settings in the crontab;
-LOGNAME may not.
+LOGNAME is the user that the job is running from, and may not be changed.
 .PP
 (Another note: the LOGNAME variable is sometimes called USER on BSD systems...
 on these systems, USER will be set also.)
@@ -73,15 +81,24 @@
 sent to the user so named.  If MAILTO is defined but empty (MAILTO=""), no
 mail will be sent.  Otherwise mail is sent to the owner of the crontab.
 .PP
+On the Debian GNU/Linux system, cron supports the
+.B pam_env
+module, and loads the environment specified by 
+.IR /etc/security/pam_env.conf .
+However, the PAM setting do
+.B NOT
+override the settings described above nor any settings in the 
+.I crontab
+file itself. Note in particular that if you want a PATH other than
+"/usr/bin:/bin", you will need to set it in the crontab file.
+.PP
 The format of a cron command is very much the V7 standard, with a number of
 upward-compatible extensions.  Each line has five time and date fields,
-followed by a command, followed by a newline character ('\n').  
+followed by a command, followed by a newline character ('\\n').  
 The system crontab (/etc/crontab) uses the same format, except that
 the username for the command is specified after the time and
-date fields and before the command.
-Note that if the line does not have a trailing newline character, the
-entire line will be silently ignored by both crontab and cron; the command
-will never be executed.
+date fields and before the command. The fields may be separated
+by spaces or tabs.
 .PP
 Commands are executed by
 .IR cron (8)
@@ -136,15 +153,16 @@
 run.
 The entire command portion of the line, up to a newline or %
 character, will be executed by /bin/sh or by the shell
-specified in the SHELL variable of the cronfile.
+specified in the SHELL variable of the crontab file.
 Percent-signs (%) in the command, unless escaped with backslash
 (\\), will be changed into newline characters, and all data
 after the first % will be sent to the command as standard
-input.
+input. There is no way to split a single command line onto multiple
+lines, ala the shell's trailing "\\".
 .PP
 Note: The day of a command's execution can be specified by two
 fields \(em day of month, and day of week.  If both fields are
-restricted (ie, aren't *), the command will be run when
+restricted (i.e., aren't *), the command will be run when
 .I either
 field matches the current time.  For example,
 .br
@@ -188,7 +206,7 @@
 # run at 2:15pm on the first of every month -- output mailed to paul
 15 14 1 * *     $HOME/bin/monthly
 # run at 10 pm on weekdays, annoy Joe
-0 22 * * 1-5	mail -s "It's 10pm" joe%Joe,%%Where are your kids?%
+0 22 * * 1-5    mail -s "It's 10pm" joe%Joe,%%Where are your kids?%
 23 0-23/2 * * * echo "run 23 minutes after midn, 2am, 4am ..., everyday"
 5 4 * * sun     echo "run at 5 after 4 every sunday"
 .fi
@@ -203,10 +221,10 @@
 SHELL=/bin/sh
 PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
 
-# m h dom mon dow user	command
-42 6	* * *	root	run-parts --report /etc/cron.daily
-47 6	* * 7	root	run-parts --report /etc/cron.weekly
-52 6	1 * *	root	run-parts --report /etc/cron.monthly
+# m h dom mon dow user    command
+42 6 * * *        root    run-parts --report /etc/cron.daily
+47 6 * * 7        root    run-parts --report /etc/cron.weekly
+52 6 1 * *        root    run-parts --report /etc/cron.monthly
 #
 # Removed invocation of anacron, as this is now handled by a 
 # /etc/cron.d file
@@ -222,7 +240,7 @@
 .PP
 Ranges can include "steps", so "1-9/2" is the same as "1,3,5,7,9".
 .PP
-Names of months or days of the week can be specified by name.
+Months or days of the week can be specified by name.
 .PP
 Environment variables can be set in the crontab.  In BSD or ATT, the
 environment handed to child processes is basically the one from /etc/rc.

=== modified file 'crontab.c'
--- crontab.c	2001-10-01 07:46:34 +0000
+++ crontab.c	2004-07-28 15:43:18 +0000
@@ -47,7 +47,6 @@
 
 #define NHEADER_LINES 3
 
-
 enum opt_t	{ opt_unknown, opt_list, opt_delete, opt_edit, opt_replace };
 
 #if DEBUGGING
@@ -58,6 +57,7 @@
 static	PID_T		Pid;
 static	char		*User, *RealUser;
 static	char		Filename[MAX_FNAME];
+static	char		Directory[MAX_FNAME];
 static	FILE		*NewCrontab = NULL;
 static	int		CheckErrorCount;
 static	enum opt_t	Option;
@@ -70,6 +70,10 @@
 			parse_args __P((int c, char *v[]));
 static	int		replace_cmd __P((void));
 
+/* Support edit command */
+static  int             create_tmp_crontab __P((void));
+static  int             open_tmp_crontab __P((struct stat *fsbuf));
+static  void            cleanup_tmp_crontab __P((void));
 
 static void
 usage(msg)
@@ -104,7 +108,6 @@
 	setlinebuf(stderr);
 #endif
 	parse_args(argc, argv);		/* sets many globals, opens a file */
-	set_cron_uid();
 	set_cron_cwd();
 	if (!allowed(User)) {
 		fprintf(stderr,
@@ -132,7 +135,7 @@
 	case opt_unknown: usage("unknown option specified");
 	                  break;
 	}
-	exit(0);
+	exit(exitstatus);
 	/*NOTREACHED*/
 }
 	
@@ -355,13 +358,148 @@
 }
 
 
+/* The next several function implement 'crontab -e' */
+
+/* Returns -1 on error, or fd to tempfile. */
+static int
+create_tmp_crontab()
+{
+        const char *template = "/crontab.XXXXXX";
+        int nfd;
+        char *tmp;
+
+        /* Create the temp directory. Note that since crontab is
+           setuid(root), TMPDIR only work for root. */
+	if ((tmp=getenv("TMPDIR")) && strlen(tmp) < MAX_FNAME) {
+	  strcpy(Directory, tmp);
+	} else {
+	  strcpy(Directory,"/tmp");
+	}
+
+        if (strlen(Directory) + strlen(template) < MAX_FNAME) {
+                strcat(Directory, template);
+        } else {
+                fprintf(stderr, "TMPDIR value is to long -- exiting\n");
+                Directory[0] = '\0';
+                return -1;
+        }
+
+        if (!mkdtemp(Directory)) {
+                perror(Directory);
+                Directory[0] = '\0';
+                return -1;
+        }
+
+        /* Now create the actual temporary crontab file */
+        if (snprintf(Filename, MAX_FNAME, "%s/crontab", Directory)
+            >= MAX_FNAME) {
+                fprintf(stderr, "Temporary filename too long - aborting\n");
+                Filename[0] = '\0';
+                return -1;
+        }
+        if ((nfd=open(Filename, O_CREAT|O_EXCL|O_WRONLY, 0600)) == -1) {
+                perror(Filename);
+                Filename[0] = '\0';
+                return -1;
+        }
+        return nfd;
+}
+
+/* Re-open the new (temporary) crontab, and check to make sure that
+   no-one is playing games. Return 0 on success, -1 on error. (Why not
+   just fopen() and stat()? Because there's no guarantee that you
+   fopen()ed the file you stat()ed.) */
+static int
+open_tmp_crontab(fsbuf)
+      struct stat *fsbuf;
+{
+        int t;
+        struct stat statbuf;
+
+        if ((t=open(Filename, O_RDONLY)) < 0) {
+                perror("Can't open tempfile after edit");
+                return -1;
+        }
+
+	if (fstat(t, &statbuf) < 0) {
+		perror("fstat");
+		return -1;
+	}
+	if (statbuf.st_uid != getuid()) {
+		fprintf(stderr, "Temporary crontab no longer owned by you.\n");
+		return -1;;
+	}
+
+        if (!S_ISREG(statbuf.st_mode)) {
+                fprintf(stderr, "The temporary crontab must remain a regular file");
+                return -1;
+        }
+
+        if (statbuf.st_mtime == fsbuf->st_mtime) {
+                return 1; /* No change to file */
+        }
+
+        NewCrontab = fdopen(t, "r");
+        if (!NewCrontab) {
+                perror("fdopen(): after edit");
+                return -1;
+        }
+        return 0;
+}
+
+/* We can't just delete Filename, because the editor might have
+   created other temporary files in there. If there's an error, we
+   just bail, and let the user/admin deal with it.*/
+
+static void
+cleanup_tmp_crontab(void) 
+{
+        DIR *dp;
+        struct dirent *ep;
+        char fname[MAX_FNAME];
+
+        if (Directory[0] == '\0') {
+                return;
+        }
+
+        /* Delete contents */
+        dp = opendir (Directory);
+        if (dp == NULL) {
+                perror(Directory);
+                return;
+        }
+
+        while ((ep = readdir (dp))) {
+                if (!strcmp(ep->d_name, ".") ||
+                    !strcmp(ep->d_name, "..")) {
+                        continue;
+                }
+                if (snprintf(fname, MAX_FNAME, "%s/%s",
+                             Directory, ep->d_name) >= MAX_FNAME) {
+                        fprintf(stderr, "filename too long to delete: %s/%s",
+                                Directory, ep->d_name);
+                        return;
+                }
+                if (unlink(fname)) {
+                        perror(ep->d_name);
+                        return;
+                }
+        }
+        (void) closedir (dp);
+
+        if (rmdir(Directory)) {
+                perror(Directory);
+                return;
+        }
+        return;
+}
+
 static void
 edit_cmd() {
 	char		n[MAX_FNAME], q[MAX_TEMPSTR], *editor;
 	FILE		*f;
 	int		ch, t, x;
-	struct stat	statbuf, fsbuf;
-	time_t		mtime;
+	struct stat     fsbuf;
 	WAIT_T		waiter;
 	PID_T		pid, xpid;
 	mode_t		um;
@@ -382,34 +520,15 @@
 	}
 
 	um = umask(077);
-#if 0
-	/* The support for TMPDIR is temporarily removed, because of
-	   interactions with emacs */
-	if (getenv("TMPDIR")) {
-	  strcpy(Filename, getenv("TMPDIR"));
-	} else {
-	  strcpy(Filename,"/tmp");
-	}
-#else
-	  strcpy(Filename,"/tmp");
-#endif
-	 
-	(void) sprintf(Filename+strlen(Filename), "/crontab.XXXXXXXXXX");
-	if ((t = mkstemp(Filename)) == -1) {
-		perror(Filename);
-		(void) umask(um);
+
+        if ((t=create_tmp_crontab()) < 0) {
+                fprintf(stderr, "Creation of temporary crontab file failed - aborting\n");
+                (void) umask(um);
 		goto fatal;
 	}
+
 	(void) umask(um);
-#ifdef HAS_FCHOWN
-	if (fchown(t, getuid(), getgid()) < 0) {
-#else
-	if (chown(Filename, getuid(), getgid()) < 0) {
-#endif
-		perror("fchown");
-		goto fatal;
-	}
-	if (!(NewCrontab = fdopen(t, "r+"))) {
+	if (!(NewCrontab = fdopen(t, "w"))) {
 		perror("fdopen");
 		goto fatal;
 	}
@@ -439,61 +558,57 @@
 		while (EOF != (ch = get_char(f)))
 			putc(ch, NewCrontab);
 	fclose(f);
-	if (fflush(NewCrontab) < OK) {
-		perror(Filename);
-		exit(ERROR_EXIT);
+
+	if (ferror(NewCrontab)) {
+		fprintf(stderr, "%s: error while writing new crontab to %s\n",
+			ProgramName, Filename);
 	}
+
 	if (fstat(t, &fsbuf) < 0) {
-		perror("unable to fstat temp file");
-		goto fatal;
-	}
- again:
-	rewind(NewCrontab);
-	if (ferror(NewCrontab)) {
-		fprintf(stderr, "%s: error while writing new crontab to %s\n",
-			ProgramName, Filename);
- fatal:		unlink(Filename);
-		exit(ERROR_EXIT);
-	}
-	if (fstat(t, &statbuf) < 0) {
-		perror("fstat");
-		goto fatal;
-	}
-	if (statbuf.st_dev != fsbuf.st_dev || statbuf.st_ino != fsbuf.st_ino) {
-		fprintf(stderr, "temp file must be edited in place\n");
-		exit(ERROR_EXIT);
-	}
-
-	mtime = statbuf.st_mtime;
-
-	if ((!(editor = getenv("VISUAL")))
-	 && (!(editor = getenv("EDITOR")))
+		perror("unable to stat temp file");
+		goto fatal;
+	}
+
+
+
+        /* Okay, edit the file */
+
+	if ((!((editor = getenv("VISUAL")) && strlen(editor)))
+	 && (!((editor = getenv("EDITOR")) && strlen(editor)))
 	    ) {
 		editor = EDITOR;
 	}
 
-	/* we still have the file open.  editors will generally rewrite the
-	 * original file rather than renaming/unlinking it and starting a
-	 * new one; even backup files are supposed to be made by copying
-	 * rather than by renaming.  if some editor does not support this,
-	 * then don't use it.  the security problems are more severe if we
-	 * close and reopen the file around the edit.
-	 */
+
+	if (fclose(NewCrontab) != 0) {
+		perror(Filename);
+                goto fatal;
+	}
+
+again: /* Loop point for retrying edit after error */
 
 	/* Turn off signals. */
 	(void)signal(SIGHUP, SIG_IGN);
 	(void)signal(SIGINT, SIG_IGN);
 	(void)signal(SIGQUIT, SIG_IGN);
+
+        /* Give up privileges while editing */
+        swap_uids();
+
 	switch (pid = fork()) {
 	case -1:
 		perror("fork");
 		goto fatal;
 	case 0:
 		/* child */
-		if (setuid(getuid()) < 0) {
-			perror("setuid(getuid())");
-			exit(ERROR_EXIT);
-		}
+                if (setgid(getgid()) < 0) {
+                        perror("setgid(getgid())");
+                        exit(ERROR_EXIT);
+                }
+                if (setuid(getuid()) < 0) {
+                        perror("setuid(getuid())");
+                        exit(ERROR_EXIT);
+                }
 		if (chdir("/tmp") < 0) {
 			perror("chdir(/tmp)");
 			exit(ERROR_EXIT);
@@ -542,19 +657,25 @@
 	(void)signal(SIGINT, SIG_DFL);
 	(void)signal(SIGQUIT, SIG_DFL);
 	(void)signal(SIGTSTP, SIG_DFL);
-	if (statbuf.st_dev != fsbuf.st_dev || statbuf.st_ino != fsbuf.st_ino) {
-		fprintf(stderr, "temp file must be edited in place\n");
-		exit(ERROR_EXIT);
-	}
-	if (fstat(t, &statbuf) < 0) {
-		perror("fstat");
-		goto fatal;
-	}
-	if (mtime == statbuf.st_mtime) {
-		fprintf(stderr, "%s: no changes made to crontab\n",
-			ProgramName);
-		goto remove;
-	}
+
+        /* Need privs again */
+        swap_uids_back();
+
+        switch (open_tmp_crontab(&fsbuf)) {
+        case -1:
+                fprintf(stderr, "Error while editing crontab\n");
+                goto fatal;
+        case 1:
+                fprintf(stderr, "No modification made\n");
+                goto remove;
+        case 0:
+                break;
+        default:
+                fprintf(stderr,
+                        "stevegr@debian.org fscked up. Send him a nasty note\n");
+                break;
+        }
+
 	fprintf(stderr, "%s: installing new crontab\n", ProgramName);
 	switch (replace_cmd()) {
 	case 0:
@@ -585,10 +706,16 @@
 		    ProgramName);
 		goto fatal;
 	}
+
  remove:
-	unlink(Filename);
+        cleanup_tmp_crontab();
  done:
 	log_it(RealUser, Pid, "END EDIT", User);
+        return;
+ fatal:
+        cleanup_tmp_crontab();
+        unlink(Filename);
+        exit(ERROR_EXIT);
 }
 
 static char tn[MAX_FNAME];
@@ -612,21 +739,12 @@
 	time_t	now = time(NULL);
 	char	**envp = env_init();
 	mode_t	um;
-	int	saved_uid;
 
 	if (envp == NULL) {
 		fprintf(stderr, "%s: Cannot allocate memory.\n", ProgramName);
 		return (-2);
 	}
 
-	/* Assume privilege.  This way we can only receive signals on our
-	   input - the ones listed below (or from root - root's problem, not
-	   ours). */
-	saved_uid = getuid();
-	if (setuid(geteuid()) < 0) {
-		perror("setuid");
-		return -2;
-	}
 
 	/* Assumes Linux-style signal handlers (takes int, returns void) */
 	/* Signal handlers, to ensure we do not leave temp files in the
@@ -640,7 +758,7 @@
 	(void) snprintf(tn, MAX_FNAME, CRON_TAB("tmp.XXXXXX"));
 	um = umask(077);
 	fd = mkstemp(tn);
-	if (!fd) {
+	if (fd < 0) {
 		perror(tn);
 		return(-2);
 	}
@@ -701,22 +819,9 @@
 	if (CheckErrorCount != 0) {
 		fprintf(stderr, "errors in crontab file, can't install.\n");
 		fclose(tmp);  unlink(tn);
-		/* Give up privilege, in case we loop. */
-		if (setreuid(saved_uid, -1) < 0)
-			return (-2);
 		return (-1);
 	}
 
-#ifdef HAS_FCHOWN
-	if (fchown(fileno(tmp), ROOT_UID, -1) < OK)
-#else
-	if (chown(tn, ROOT_UID, -1) < OK)
-#endif
-	{
-		perror("chown");
-		fclose(tmp);  unlink(tn);
-		return (-2);
-	}
 
 #ifdef HAS_FCHMOD
 	if (fchmod(fileno(tmp), 0600) < OK)
@@ -724,17 +829,27 @@
 	if (chmod(tn, 0600) < OK)
 #endif
 	{
-		perror("chown");
+		perror("chmod");
 		fclose(tmp);  unlink(tn);
 		return (-2);
 	}
 
+
 	if (fclose(tmp) == EOF) {
 		perror("fclose");
 		unlink(tn);
 		return (-2);
 	}
 
+        /* Root on behalf of another user must set file owner to that user */
+        if (getuid() == ROOT_UID && strcmp(User, RealUser) != 0) {
+            if (chown(tn, pw->pw_uid, -1) != 0) {
+                perror("chown");
+                unlink(tn);
+                return -2;
+            }
+        }
+
 	(void) snprintf(n, sizeof(n), CRON_TAB(User));
 	if (rename(tn, n)) {
 		fprintf(stderr, "%s: error renaming %s to %s\n",
@@ -743,15 +858,12 @@
 		unlink(tn);
 		return (-2);
 	}
+
+
 	log_it(RealUser, Pid, "REPLACE", User);
 
 	poke_daemon();
 
-	/* Give up privilege, just in case. */
-	/* Don't need to check for error; nothing happens beyond here but a log entry,
-	   and the failure message is incorrect after the rename above. */
-	setreuid(saved_uid, -1);
-
 	return (0);
 }
 

=== modified file 'database.c'
--- database.c	2001-10-01 07:46:34 +0000
+++ database.c	2004-07-28 15:43:18 +0000
@@ -24,11 +24,12 @@
 
 
 #include "cron.h"
+#define __USE_GNU /* For O_NOFOLLOW */
 #include <fcntl.h>
+#undef __USE_GNU
 #include <sys/stat.h>
 #include <sys/file.h>
 
-
 #define TMAX(a,b) ((a)>(b)?(a):(b))
 
 /* Try to get maximum path name -- this isn't really correct, but we're
@@ -165,7 +166,7 @@
 	new_db.head = new_db.tail = NULL;
 
 	if (syscron_stat.st_mtime) {
-		process_crontab("root", "*system*",
+		process_crontab(SYSUSERNAME, "*system*",
 				SYSCRONTAB, &syscron_stat,
 				&new_db, old_db);
 	}
@@ -203,7 +204,7 @@
 
 		/* statbuf is used as working storage by process_crontab() --
 		   current contents are irrelevant */
-		process_crontab("root", fname, tabname,
+		process_crontab(SYSUSERNAME, fname, tabname,
 				&statbuf, &new_db, old_db);
 
 	}
@@ -338,18 +339,66 @@
 		goto next_crontab;
 	}
 
-	if ((crontab_fd = open(tabname, O_RDONLY, 0)) < OK) {
-		/* crontab not accessible?
-		 */
-		log_it(fname, getpid(), "CAN'T OPEN", tabname);
-		goto next_crontab;
-	}
-
-	if (fstat(crontab_fd, statbuf) < OK) {
-		log_it(fname, getpid(), "FSTAT FAILED", tabname);
-		goto next_crontab;
-	}
-
+        if (pw) {
+            /* Path for user crontabs (including root's!) */
+            if ((crontab_fd = open(tabname, O_RDONLY|O_NOFOLLOW, 0)) < OK) {
+		/* crontab not accessible?
+		 */
+		log_it(fname, getpid(), "CAN'T OPEN", tabname);
+		goto next_crontab;
+            }
+
+            if (fstat(crontab_fd, statbuf) < OK) {
+		log_it(fname, getpid(), "FSTAT FAILED", tabname);
+		goto next_crontab;
+            }
+            /* Check to make sure that the crontab is owned by the correct user
+               (or root) */
+
+            if (statbuf->st_uid != pw->pw_uid &&
+                statbuf->st_uid != ROOT_UID) {
+                log_it(fname, getpid(), "WRONG FILE OWNER", tabname);
+		goto next_crontab;
+            }
+            if (!S_ISREG(statbuf->st_mode) ||
+                statbuf->st_nlink != 1 ||
+                (statbuf->st_mode & 07777) != 0600) {
+                log_it(fname, getpid(), "WRONG INODE INFO", tabname);
+ 		goto next_crontab;
+            }
+        } else {
+            /* System crontab path. These can be symlinks, but the
+               symlink and the target must be owned by root. */
+            if (lstat(tabname, statbuf) < OK) {
+		log_it(fname, getpid(), "LSTAT FAILED", tabname);
+		goto next_crontab;
+            }
+            if (statbuf->st_uid != ROOT_UID) {
+                log_it(fname, getpid(), "WRONG SYMLINK OWNER", tabname);
+		goto next_crontab;
+            }
+            if ((crontab_fd = open(tabname, O_RDONLY, 0)) < OK) {
+		/* crontab not accessible?
+		 */
+		log_it(fname, getpid(), "CAN'T OPEN", tabname);
+		goto next_crontab;
+            }
+
+            if (fstat(crontab_fd, statbuf) < OK) {
+		log_it(fname, getpid(), "FSTAT FAILED", tabname);
+		goto next_crontab;
+            }
+            /* Check to make sure that the crontab is owned by root */
+            if (statbuf->st_uid != ROOT_UID) {
+                log_it(fname, getpid(), "WRONG FILE OWNER", tabname);
+		goto next_crontab;
+            }
+        }
+        /*
+         * The link count check is not sufficient (the owner may
+         * delete their original link, reducing the link count back to
+         * 1), but this is all we've got.
+         */
 	Debug(DLOAD, ("\t%s:", fname))
 	u = find_user(old_db, fname);
 	if (u != NULL) {
@@ -375,7 +424,8 @@
 		free_user(u);
 		log_it(fname, getpid(), "RELOAD", tabname);
 	}
-	u = load_user(crontab_fd, pw, fname);
+
+	u = load_user(crontab_fd, pw, uname, fname, tabname);
 	if (u != NULL) {
 		u->mtime = statbuf->st_mtime;
 		link_user(new_db, u);
@@ -390,24 +440,44 @@
 
 #ifdef DEBIAN
 
-/* True or false? Is this a valid filename (upper/lower alpha, digits,
- * underscores, and hyphens only?)
- */
-#include <ctype.h>
-/* Same function, better compliance with ISO C */
-static int valid_name (char *filename)
+#include <regex.h>
+
+/* True or false? Is this a valid filename? */
+
+/* Taken from Clint Adams 'run-parts' version to support lsb style
+   names, originally GPL, but relicensed to cron license per e-mail of
+   27 September 2003. I've changed it to do regcomp() only once. */
+
+int valid_name(char *filename)
 {
-  while (*filename) {
-    if (!(isalnum(*filename) ||
-	  (*filename == '_') ||
-	  (*filename == '-')))
-      return 0;
-    ++filename;
-  }
+  static regex_t hierre, tradre, excsre, classicalre;
+  static int donere = 0;
 
-  return 1;
+  if (!donere) {
+      donere = 1;
+      if (regcomp(&hierre, "^_?([a-z0-9_.]+-)+[a-z0-9]+$",
+                  REG_EXTENDED | REG_NOSUB)
+          || regcomp(&excsre, "^[a-z0-9-].*dpkg-(old|dist)$",
+                     REG_EXTENDED | REG_NOSUB)
+          || regcomp(&tradre, "^[a-z0-9][a-z0-9-]*$", REG_NOSUB)
+          || regcomp(&classicalre, "^[a-zA-Z0-9_-]+$",
+                     REG_EXTENDED | REG_NOSUB)) {
+          log_it("CRON", getpid(), "REGEX FAILED", "valid_name");
+          (void) exit(ERROR_EXIT);
+      }
+  }
+  if (lsbsysinit_mode) {
+      if (!regexec(&hierre, filename, 0, NULL, 0)) {
+          return regexec(&excsre, filename, 0, NULL, 0);
+      } else {
+          return !regexec(&tradre, filename, 0, NULL, 0);
+      }
+  }
+  /* Old standard style */
+  return !regexec(&classicalre, filename, 0, NULL, 0);
 }
 
+
 static user *
 get_next_system_crontab (curtab)
 	user	*curtab;

=== added file 'debian/NEWS'
--- debian/NEWS	1970-01-01 00:00:00 +0000
+++ debian/NEWS	2004-07-28 15:43:18 +0000
@@ -0,0 +1,9 @@
+cron (3.0pl1-74) unstable; urgency=low
+
+    The checksecurity script is no longer included with the cron package:
+    it now has its own package, "checksecurity". If you liked the
+    functionality provided with that script, please install the new
+    package.
+
+ -- Steve Greenland <stevegr@debian.org>  Sat,  6 Sep 2003 17:15:03 -0500
+

=== modified file 'debian/README.debian'
--- debian/README.debian	2001-10-01 07:46:34 +0000
+++ debian/README.debian	2004-07-28 15:43:18 +0000
@@ -14,10 +14,6 @@
 package maintenance scheme in the form of various files (now in the
 debian directory).
 
-The `checksecurity' script installed in /usr/sbin in the binary distribution
-(found in ./debian in the source) was (probably) written by Ian Jackson,
-and has been modified by Steve Greenland.
-
 File locations that are different than that indicated in 
 the cron distributions README:
 

=== modified file 'debian/changelog'
--- debian/changelog	2001-10-01 07:46:34 +0000
+++ debian/changelog	2004-07-28 15:43:18 +0000
@@ -1,3 +1,167 @@
+cron (3.0pl1-86) unstable; urgency=high
+
+  * And yes, still needs urgency=high.
+
+ -- Steve Greenland <stevegr@debian.org>  Wed, 28 Jul 2004 15:43:18 -0500
+
+cron (3.0pl1-85) unstable; urgency=low
+
+  * Umm, yeah, need the 'install' file in CVS. 
+
+ -- Steve Greenland <stevegr@debian.org>  Wed, 28 Jul 2004 15:31:28 -0500
+
+cron (3.0pl1-84) unstable; urgency=high
+
+  * Urgency "high" to make the sudden freeze. 
+  * Exit with failure status from crontab when action fails (thanks to
+    Christoph Berg for noticing and the patch) (closes: #229604)
+  * Require anacron to be executable (closes: #240822)
+  * Set ttyname to prevent pam_access confusion. Problem and solution from
+    Daniel Kobras (it's nice to get both!) (closes: #254845)
+  * Fix reference to syslogd(8) in cron.8 (closes: #246580)
+  * Fix awkward construction in crontab.5 (closes: #252420)
+  * Cleanup explanation of LOGNAME in crontab.5 (closes: #257672)
+  * Don't use --exec in start-stop-daemon calls.
+
+ -- Steve Greenland <stevegr@debian.org>  Mon, 26 Jul 2004 10:40:22 -0500
+
+cron (3.0pl1-83) unstable; urgency=low
+
+  * Update default MTA from exim to exim4 (closes:#228561)
+
+ -- Steve Greenland <stevegr@debian.org>  Mon, 19 Jan 2004 16:39:52 -0600
+
+cron (3.0pl1-82) unstable; urgency=low
+
+  * Added /etc/cron.d/.placeholder to prevent dpkg from removing the
+    directory when all packages using /etc/cron.d are purged. Likewise to
+    cron.weekly (which needs it), and cron.daily and cron.monthly (which
+    don't, but I like consistency.) (closes: #217760)
+  * Add '--retry 5' to the stop part of /etc/init.d/cron restart, so that
+    cron is completely stopped before attempting restart. (closes: #223945)
+  * Add cron.hourly directory (closes:#200848, #219338, #226710)
+  * Support the LSB naming convention for /etc/cron.d (closes: #171587)
+  * Move cron.d manual section out of DEBIAN SPECIFIC, since many
+    distributions now support this. (closes:#2277770)
+  * Clarify that environment setting are not re-expanded (closes: #223570)
+  * Some crontab(5) man page fixups (closes: #200100)
+
+ -- Steve Greenland <stevegr@debian.org>  Sun, 18 Jan 2004 16:20:59 -0600
+
+cron (3.0pl1-81) unstable; urgency=low
+
+  * Only protect owner/group setting on individual user crontabs by
+    version, the setgid setting of /usr/bin/crontab needs to happen every
+    time (unless the admin has set something with
+    dpkg-statoverride. (closes: #210838)
+  * Change cron init script so that '/etc/init.d/cron {stop,restart}' only
+    kill off the parent daemon, not currently running cron jobs. Much
+    thanks to Dean Gaudet for the patch. (closes: #211849)
+
+ -- Steve Greenland <stevegr@debian.org>  Sun, 21 Sep 2003 16:37:16 -0500
+
+cron (3.0pl1-80) unstable; urgency=low
+
+  * Kill one last spurious syslog() (closes: #211117, #211245)
+  * Allow system crontabs to be symlinks (closes: #210467)
+
+ -- Steve Greenland <stevegr@debian.org>  Wed, 17 Sep 2003 19:15:55 -0500
+
+cron (3.0pl1-79) unstable; urgency=low
+
+  * Don't exit postinst when user is unkown (closes: #208432)
+  * Remove spurious debug messages (closes: #211117)
+
+ -- Steve Greenland <stevegr@debian.org>  Tue, 16 Sep 2003 08:26:17 -0500
+
+cron (3.0pl1-78) unstable; urgency=low
+
+  * Okay, I think the owner/group fixup in for setgid crontabs is finally
+    as right as it's going to be. It will work for usernames with spaces,
+    and if the user doesn't exist (e.g. old crontab for a deleted user),
+    it will print an error message but not exit, which I think is okay. If
+    you have a username with a newline in it, then you deserve to lose,
+    and you will (closes: #210838).
+  * Allow cron to run in foreground. Possibly useful for running it under
+    monitoring tools like runit, monit, daemontools, etc. Thanks to Erich
+    Schubert for the patch (closes: #108492)
+  * Use the PAM environment settings, if so configured. (closes: #203737)
+
+ -- Steve Greenland <stevegr@debian.org>  Sun, 14 Sep 2003 16:53:36 -0500
+
+cron (3.0pl1-77) unstable; urgency=low
+
+  * Smarter fix-up of crontabs groups (closes: #208555)
+  * Add dependency for adduser (closes: #208848)
+  * Support new PAM @includes for standard PAM configuration.
+  * Move note about loss of checksecurity from debconf to NEWS.Debian.gz,
+    the more appropriate place. Since that was the only use of debconf,
+    this also (closes: #195887)
+  * Add commented-out pam_limits support. (closes: 190556)
+
+ -- Steve Greenland <stevegr@debian.org>  Sat,  6 Sep 2003 18:47:02 -0500
+
+cron (3.0pl1-76) unstable; urgency=low
+
+  * Fix postinst bug for no user crontabs (closes: #208433, #208435, #208448)
+
+ -- Steve Greenland <stevegr@debian.org>  Tue,  2 Sep 2003 18:05:31 -0500
+
+cron (3.0pl1-75) unstable; urgency=low
+
+  * Make crontab setgid 'crontab' rather than setuid 'root' (closes: #18333)
+
+ -- Steve Greenland <stevegr@debian.org>  Mon,  1 Sep 2003 18:57:14 -0500
+
+cron (3.0pl1-74) unstable; urgency=low
+
+  * Split out the checksecurity script et. al. to seperate package
+    'checksecurity'
+  * Detect missing or stupid stepsize (e.g. */ or 7-9/0) (closes: #183650)
+  * Allow for crontab editors that don't write to the same file. Finally.
+    (closes: #149908)
+  * Don't weird out if VISUAL or EDITOR is set to "" (closes: #148809)
+  * Fixed several documentation/script typos and clarifications
+    (closes: #149448)
+  * Standards-Version 3.5.9
+
+ -- Steve Greenland <stevegr@debian.org>  Sun,  1 Jun 2003 15:02:23 -0500
+
+cron (3.0pl1-73) unstable; urgency=low
+
+  * Fixed spelling error in control file (Hi, Matt!) (closes: #124523)
+  * Check for existence of /etc/init.d/cron in prerm (closes:#151006)
+  * Added conflict for ancient version of lockfile-progs (closes: #123269)
+  * Added Mosix FS to list of excluded FS types in checksecurity.conf 
+    (closes: #129177)
+  * chmod group.bak instead of passwd.bak twice (closes: #130079)
+  * Added ext3 for lost+found searches (closes:#135013)
+  * Finally fixed longstanding bug where cron doesn't recognize crontab
+    changes until 1 minute later. I don't know what I was looking at before,
+    as it was trivial. I apologize to all those bothered by this problem.
+    (closes: #74524, #13952)
+  * Remove debian/preinst, used only for a fix for a pre-slink development
+    release.
+  * Added support for invoke-rc.d, patch from Andreas Metzler (closes:#162676)
+  * Finally figured out why some error messages weren't getting printed
+    for the system crontabs (/etc/crontab, /etc/cron.d/*). Added new error
+    printing function and use it when user.c calls load_entry(). 
+    (closes:#79037, #122358)
+  * Remove -odi option from invocation of /usr/sbin/sendmail. (closes:#146224)
+  * Don't run @monthly jobs every day. (closes: #150591). Ditto
+    @yearly. (Isn't it funny that despite the big whinefest about how
+    critically important the @whatever timespecs are, nobody previously
+    noticed this serious bug in the entire 7+ years I've been maintaining
+    cron?)
+  * Fix grammatical here in the cron(8) manpage. (closes: 147277)
+  * Fix spelling error in checksecurity.conf. (closes: #151601)
+  * Fix check for nfs/afs mounts in checksecurity. (closes: #157822)
+  * Replaced some tabs with spaces in crontab.5. (closes: #159912)
+  * Fix cron Makefile to not hardcode '-s' in $(INSTALL) commands.
+    (closes: #164966)
+
+ -- Steve Greenland <stevegr@debian.org>  Mon,  4 Nov 2002 18:14:45 -0600
+
 cron (3.0pl1-72) unstable; urgency=low
 
   * Add type usbdevfs to skipped "file systems" (this is /proc/bus/usb)

=== removed file 'debian/checksecurity'
--- debian/checksecurity	2001-10-01 07:46:34 +0000
+++ debian/checksecurity	1970-01-01 00:00:00 +0000
@@ -1,87 +0,0 @@
-#!/bin/sh
-# Security checks script - run daily out of the system crontab
-
-set -e
-
-PATH=/sbin:/bin:/usr/sbin:/usr/bin
-
-
-umask 027
-cd /
-
-. /etc/checksecurity.conf
-
-if [ "$CHECKSECURITY_DISABLE" = "TRUE" ] ; then
-    exit
-fi
-
-if [ -z "$CHECKSECURITY_GREPOUT" ]; then
-    CHECKSECURITY_GREPOUT="$^"
-fi
-
-TMPSETUID=${LOGDIR:=/var/log}/setuid.new.tmp
-TMPDIFF=${LOGDIR:=/var/log}/setuid.diff.tmp
-
-#
-# Check for NFS/AFS mounts that are not nosuid/nodev
-#
-if [ ! "$CHECKSECURITY_NONFSAFS" = "TRUE" ] ; then
-   # temporarily disable error exit, as grep may give errors if no nfs/afs
-   # are mounted.
-   set +e
-   nfssys=`mount | grep -E 'nfs|afs' | grep -vE '\(.*(nosuid|noexec).*nodev.*\)'`
-   nfssyscnt=`echo $nfssys |grep "[a-z]"| wc -l`
-   set -e
-   if [ $nfssyscnt -gt 0 ] ; then
-      echo "The following NFS or AFS filesystems are mounted insecurely:"
-      echo ""
-      echo $nfssys
-      echo ""
-      echo "If this is intentional and you have supreme confidence in the"
-      echo "security of the server for these file systems, you may disable"
-      echo "this message by editing the value of CHECKSECURITY_NONFSAFS in"
-      echo "the file /etc/checksecurity.conf."
-   fi
-fi
-
-if [ "$CHECKSECURITY_NOFINDERRORS" = "TRUE" ] ; then
-	exec 9>&2
-	exec 2>/dev/null
-fi
-
-
-# This is the only way to pass '*' through a variable (NODEVDIRS)  -- Marc
-set -o noglob
-find `mount | grep -vE "$CHECKSECURITY_FILTER" | cut -d ' ' -f 3` \
-    -xdev \(  $CHECKSECURITY_PATHFILTER \) -prune -o \
-    \( -type f -perm +06000 -o \
-    \( \( -type b -o -type c \) -a -not \( $CHECKSECURITY_DEVICEFILTER \) \) \) \
-    -printf "%8i %5m %3n %-10u %-10g %9s %t %h/%f\n" | sort >$TMPSETUID
-set +o noglob
-
-if [ "$CHECKSECURITY_NOFINDERRORS" = "TRUE" ] ; then
-	exec 2>&9
-fi
-
-cd $LOGDIR
-
-test -f setuid.today || touch setuid.today
-
-if cmp -s setuid.today $TMPSETUID >/dev/null
-then
-    :
-else
-	diff -u0 setuid.today $TMPSETUID >> $TMPDIFF || [ $? = 1 ]
-	echo "`hostname` changes to setuid programs and devices:" 
-	cat $TMPDIFF 
-	
-	if [ `cat $TMPDIFF | wc -l` -gt 0 -a ! -z "$CHECKSECURITY_EMAIL" ]; then
-		/usr/bin/mail -s "Setuid changes for `hostname -f` on `date '+%D %T'`" $CHECKSECURITY_EMAIL < $TMPDIFF
-	fi
-	
-	mv setuid.today setuid.yesterday
-	mv $TMPSETUID setuid.today
-        chown root.adm setuid.today
-fi
-rm -f $TMPDIFF
-rm -f $TMPSETUID

=== removed file 'debian/checksecurity.8'
--- debian/checksecurity.8	2001-10-01 07:46:34 +0000
+++ debian/checksecurity.8	1970-01-01 00:00:00 +0000
@@ -1,145 +0,0 @@
-.\" -*- nroff -*-
-.TH CHECKSECURITY 8 "2 February 1997" "Debian Linux"
-.SH NAME
-checksecurity \- check for changes to setuid programs
-.SH SYNOPSIS
-.B checksecurity
-.SH DESCRIPTION
-The
-.B checksecurity
-command scans the mounted files systems (subject to the filter defined
-in /etc/checksecurity.conf) and compares the list of setuid programs to the
-list created on the previous run. Any changes are printed to standard
-output. Also, it generates a list of 
-.I nfs
-and 
-.I afs
-filesystems that are mounted insecurely (i.e. they are missing the 
-.I nodev 
-and either the
-.I noexec
-or
-.I nosuid 
-flags).
-.PP
-.B checksecurity
-is run by 
-.B cron
-on a daily basis, and the output stored in /var/log/setuid.changes.
-.SH CONFIGURATION
-The
-.B checksecurity.conf
-file defines several configuration variables:
-.BR CHECKSECURITY_FILTER ,
-.BR CHECKSECURITY_NOFINDERRORS ,
-.BR CHECKSECURITY_DISABLE ,
-.BR CHECKSECURITY_NONFSAFS ,
-.BR CHECKSECURITY_EMAIL ,
-.BR CHECKSECURITY_DEVICEFILTER ,
-.BR CHECKSECURITY_PATHFILTER , 
-and
-.BR LOGDIR .
-Each is described below.
-.PP
-The 
-.B CHECKSECURITY_FILTER
-environment variable which is the argument of 'grep -vE' applied to
-the output of the  
-.B mount
-command. In other words, the value of
-.B CHECKSECURITY_FILTER
-is a regular expression that removes matching lines from those
-file systems that will be scanned. The default value removes
-all file systems of type 
-.I proc, msdos, iso9660, ncpfs, nfs, afs,
-.I smbfs, auto, ntfs, coda
-file systems, 
-anything mounted on /dev/fd*, anything mounted
-on /mnt or /amd, and anything mounted with option nosuid or noexec.
-.PP
-The
-.B checksecurity.conf
-file is sourced from 
-.B checksecurity,
-so you could do some fairly tricky things to define 
-.BR CHECKSECURITY_FILTER .
-.PP
-The 
-.B CHECKSECURITY_NOFINDERRORS 
-environment variable, if set to the literal "TRUE", disables
-find errors from checksecurity (actually, it re-routes them to 
-.B /dev/null
-).
-.PP
-The
-.B CHECKSECURITY_DISABLE  
-environment variable, if set to the literal "TRUE", disables
-checksecurity entirely, as a sop to those who think it's safe to allow
-random mounting of NFS and AFS disks without the nosuid or noexec flags.
-.PP
-The
-.B CHECKSECURITY_NONFSAFS
-environment variable, if set to the literal "TRUE", disables the message about 
-.I nfs
-and
-.I afs
-file systems that are mounted without the
-.I nodev 
-and either the
-.I noexec
-or
-.I nosuid 
-options.
-.PP
-If set, the 
-.B CHECKSECURITY_EMAIL
-variable defines who is sent a copy of the setuid.changes file.
-.PP
-The
-.B CHECKSECURITY_DEVICEFILTER
-variable specifies a 
-.B find
-clause for which matching block and character device files will not be
-monitored for changing owners and permissions. For example, if you
-didn't want to check for permission changes on tty device files
-beneath /dev, you could set the following:
-.PP
-.RS
-CHECKSECURITY_DEVICEFILTER='-path /dev/tty*'
-.RE
-.PP
-Note that any added or modified suid programs under that path would
-still be detected. If you want to specify multiple expressions,
-separate them with '-o', but there is no need to surround the whole
-clause with parentheses. To disable this filter, specify it as
-'-false' (which is the default).
-.PP
-The
-.B CHECKSECURITY_PATHFILTER
-variable specifies a 
-.B find
-clause which will be pruned from the search path.
-.B This means that the entire subtree will be completely skipped.
-Thus, specifying  
-.PP
-.RS
-CHECKSECURITY_PATHFILTER='-path /var/ftp'
-.RE
-.PP
-then the entire /var/ftp tree will be skipped. To disable this filter,
-specify it as '-false' (which is the default).
-.PP
-.B LOGDIR
-sets the name of the directory which stores the files which track
-the permission and ownership changes. By default, they are in 
-.BR /var/log .
-.SH FILES
-.TP
-.I /etc/checksecurity.conf
-checksecurity configuration file
-.TP
-.I /var/log/setuid.today
-setuid files from the most recent run
-.TP
-.I /var/log/setuid.yesterday
-setuid files from the previous run

=== removed file 'debian/checksecurity.conf'
--- debian/checksecurity.conf	2001-10-01 07:46:34 +0000
+++ debian/checksecurity.conf	1970-01-01 00:00:00 +0000
@@ -1,126 +0,0 @@
-#
-# This is the checksecurity script configuration file
-#
-# These configuration variables mabye set:
-# 
-#     CHECKSECURITY_FILTER
-#     CHECKSECURITY_NOFINDERRORS
-#     CHECKSECURITY_DISABLE
-#     CHECKSECURITY_NONFSAFS
-#     CHECKSECURITY_EMAIL
-#     CHECKSECURITY_DEVICEFILTER
-#     CHECKSECURITY_PATHFILTER
-#     LOGDIR
-# 
-# Each is described in it's own section below -- search for ####
-# as a section divider.
-#
-####
-#
-# The CHECKSECURITY_FILTER variable is used as an argument to
-# "grep -vE" to filter lines from the output of the "mount"
-# command. 
-#
-# The default is not check the following file systems:
-#
-#   type proc
-#   type msdos
-#   type iso9660
-#   type ncpfs
-#   type smbfs
-#   type nfs
-#   type afs
-#   type auto (They'll typically be picked up on the nfs branch)
-#   type ntfs
-#   type coda (similar to afs)
-#   type usbdevfs
-#   type none (--bind mounts)
-#
-#   floppies (i.e. /dev/fd<whatever>)
-#   anything on /mnt or /amd
-#
-# Note that behaviour for nfs/afs has changed as of release -45. We
-# no longer run find across nfs/afs disks; instead we simply report
-# afs/nfs disks that are mounted insecurely (without -onosuid|noexec,nodev).
-# You can disable this report by going setting the CHECKSECURITY_NONFSAFS 
-# variable below.
-#
-# Use temp variables to build up CHECKSECURITY_FILTER, to make it
-# a little more readable.
-#
-CS_NFSAFS='(nfs|afs|coda)'
-# Uncomment the next line to get the old behaviour.
-#CS_NFSAFS='(nfs|afs) \(.*(nosuid|noexec).*nodev.*\)'
-#
-CS_TYPES=' type (auto|proc|msdos|fat|vfat|iso9660|usbdevfs|ncpfs|smbfs|ntfs|devpts|none|'$CS_NFSAFS')'
-#
-CS_OPTS='\(.*(nosuid|noexec).*\)'
-#
-CS_DEVS='^/dev/fd'
-#
-CS_DIRS='on /mnt'
-#
-CHECKSECURITY_FILTER="$CS_TYPES|$CS_OPTS|$CS_DEVS|$CS_DIRS"
-#
-# Clear the temporary variables
-#
-unset CS_NFSAFS CS_TYPES CS_DIRS CS_OPTS
-#
-####
-#
-# The CHECKSECURITY_NOFINDERRORS, if set to "TRUE" (case sensitive),
-# redirects any errors from the find command used in checksecurity
-# to /dev/null.
-#
-CHECKSECURITY_NOFINDERRORS="FALSE"
-####
-#
-# The CHECKSECURITY_DISABLE, if set to "TRUE" (case sensitive),
-# disables the running of checksecurity
-#
-CHECKSECURITY_DISABLE="FALSE"
-####
-#
-# The CHECKSECURITY_NONFSAFS, if set to "TRUE" (case sensitive),
-# disables the message about insecurely mounted nfs/afs disks
-#
-CHECKSECURITY_NONFSAFS="FALSE"
-####
-#
-# If the CHECKSECURITY_EMAIL is set, the report is mailed to the given
-# address. Note that if you set this, it is *assumed* that you have
-# /usr/bin/mail that accepts -s; the mailx package provides this; or
-# you can install mutt and create a link, or some other
-# alternative. No, I'm not going to fix it to write the appropriate
-# headers and use sendmail (although I'd consider patch), nor am I
-# going to add a {Depends|Recommends|Suggests} to the cron package.
-# Do not submit bugs about this unless you include the above mentioned
-# patch. You enabled this option -- you take responsibility.
-#
-#CHECKSECURITY_EMAIL="root"
-####
-#
-# The CHECKSECURITY_DEVICEFILTER lets you tell find not to report
-# devices in those directories (if you choose the daily Emails,
-# devices like /dev/pts/?, /dev/tty?, or /dev/urandom will change
-# often and clutter your mailbox) Note that these directories are
-# still searched for suid executables.  Also not that *something* must
-# be defined, which is why the default is "-false".
-# Examples:
-#CHECKSECURITY_DEVICEFILTER="-path /dev/*"
-#CHECKSECURITY_DEVICEFILTER="-path /dev/* -o -path /home/ftp/dev/*"
-CHECKSECURITY_DEVICEFILTER="-false"
-####
-# The CHECKSECURITY_PATHFILTER variable lets you set a pattern of
-# pathnames that you don't want to check at all. You hopefully know
-# what you're doing if you do this :-).
-# Example:
-# CHECKSECURITY_PATHFILTER="-path /dev/rd* -o -path /var/home/ftp*"
-CHECKSECURITY_PATHFILTER="-false"
-####
-#
-# Location of setuid file databases. Probably should
-# be in /var/lib/cron, but I don't want to move them now. After
-# the release, maybe.
-#
-LOGDIR=/var/log

=== modified file 'debian/conffiles.nopam'
--- debian/conffiles.nopam	2001-10-01 07:46:34 +0000
+++ debian/conffiles.nopam	2004-07-28 15:43:18 +0000
@@ -1,5 +1,9 @@
-/etc/checksecurity.conf
 /etc/crontab
 /etc/init.d/cron
 /etc/cron.daily/standard
 /etc/cron.monthly/standard
+/etc/cron.hourly/.placeholder
+/etc/cron.daily/.placeholder
+/etc/cron.weekly/.placeholder
+/etc/cron.monthly/.placeholder
+/etc/cron.d/.placeholder

=== modified file 'debian/conffiles.pam'
--- debian/conffiles.pam	2001-10-01 07:46:34 +0000
+++ debian/conffiles.pam	2004-07-28 15:43:18 +0000
@@ -1,6 +1,10 @@
-/etc/checksecurity.conf
 /etc/crontab
 /etc/init.d/cron
 /etc/cron.daily/standard
 /etc/cron.monthly/standard
 /etc/pam.d/cron
+/etc/cron.hourly/.placeholder
+/etc/cron.daily/.placeholder
+/etc/cron.weekly/.placeholder
+/etc/cron.monthly/.placeholder
+/etc/cron.d/.placeholder

=== modified file 'debian/control'
--- debian/control	2001-10-01 07:46:34 +0000
+++ debian/control	2004-07-28 15:43:18 +0000
@@ -2,15 +2,15 @@
 Section: admin
 Priority: important
 Maintainer: Steve Greenland <stevegr@debian.org>
-Standards-Version: 3.5.2
-Build-Depends: debhelper, libpam0g-dev
+Standards-Version: 3.6.1
+Build-Depends: debhelper, libpam0g-dev, libselinux1-dev
 
 Package: cron
 Architecture: any
-Depends: ${shlibs:Depends}, debianutils (>=1.7)
-Recommends: exim | smail | sendmail | mail-transport-agent
-Suggests: anacron (>=2.0-1), logrotate, lockfile-progs
-Conflicts: suidmanager (<< 0.50)
+Depends: ${shlibs:Depends}, debianutils (>=1.7), adduser
+Recommends: exim4 | postfix | mail-transport-agent
+Suggests: anacron (>=2.0-1), logrotate, lockfile-progs, checksecurity
+Conflicts: suidmanager (<< 0.50), lockfile-progs (<< 0.1.7)
 Provides:
 Description: management of regular background processing
  cron is a background process (`daemon') that runs programs at regular
@@ -30,6 +30,6 @@
  grow endlessly and overflow the disk.
  .
  The lockfile-progs package is only a "Suggests" because of the poor
- way that dselect handles "Recomments", but I do strongly suggest that
+ way that dselect handles "Recommends", but I do strongly suggest that
  you install it; it prevents /etc/cron.daily/standard from running multiple
  times if something gets jammed.

=== modified file 'debian/copyright'
--- debian/copyright	2001-10-01 07:46:34 +0000
+++ debian/copyright	2004-07-28 15:43:18 +0000
@@ -14,26 +14,28 @@
 The original source for this package may be obtained from 
 ftp://ftp.vix.com/pub/vixie/cron-3.0.
 
+Code and regex in database.c/valid_name() from Clint Adams, relicensed
+to cron license above from e-mail:
+
+    Date: Sat, 27 Sep 2003 12:20:49 -0400
+    From: Clint Adams <schizo@debian.org>
+    To: Steve Greenland <steveg@moregruel.net>
+    
+    > So, I think I'm going to do the same wimp-out thing: add a switch,
+    > and lift the code from run-parts to implement it. Oh, crap, it's G P L,
+    > and vixie cron isn't. Clint, would you be willing to relicense
+    > your
+    > "valid_names()" function under the following:
+    > 
+    > [ommitted, same as above]
+    
+    I could have sworn that I replied to this back in May.  I'm willing to
+    relicense it under the cron license, though I still think a shared
+    library is the way to go.
+
+
+
+
 Modifications for Debian GNU/Linux Copyright 1994 Ian Jackson;
-checksecurity script:
 Copyright (C) 1994 Ian Jackson
-Copyright (C) 1996, 1997, 1998, 1999, 2000 Steve Greenland
-
-The `checksecurity' script and its associated files (checksecurity.8
-and checksecurity.conf) are free software; you can redistribute it
-and/or modify it under the terms of the GNU General Public License as
-published by the Free Software Foundation; either version 2, or (at
-your option) any later version.
-
-This program is distributed in the hope that it will be useful, but
-WITHOUT ANY WARRANTY; without even the implied warranty of
-MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-General Public License for more details.
-
-A copy of the GNU General Public License is available as
-`/usr/share/common-licenses/GPL' in the 
-Debian GNU/Linux distribution or on the World Wide Web
-at `http://www.gnu.org/copyleft/gpl.html'. You can also obtain it by
-writing to the Free Software Foundation, Inc., 59 Temple Place - Suite
-330, Boston, MA 02111-1307, USA.
-
+Copyright (C) 1996, 1997, 1998, 1999, 2000, 2001, 2002, 2003, 2004 Steve Greenland

=== added file 'debian/cron-se.dirs'
--- debian/cron-se.dirs	1970-01-01 00:00:00 +0000
+++ debian/cron-se.dirs	2004-07-28 15:43:18 +0000
@@ -0,0 +1,2 @@
+usr/bin
+usr/sbin

=== added file 'debian/cron-se.install'
--- debian/cron-se.install	1970-01-01 00:00:00 +0000
+++ debian/cron-se.install	2004-07-28 15:43:18 +0000
@@ -0,0 +1,3 @@
+b-cron-se/cron usr/sbin
+b-cron-se/crontab usr/bin
+b-cron-se/cron-se usr/share/lintian/overrides
\ No newline at end of file

=== added file 'debian/cron-se.overrides'
--- debian/cron-se.overrides	1970-01-01 00:00:00 +0000
+++ debian/cron-se.overrides	2004-07-28 15:43:18 +0000
@@ -0,0 +1,2 @@
+cron-se: binary-without-manpage cron
+cron-se: binary-without-manpage crontab

=== added file 'debian/cron-se.postinst'
--- debian/cron-se.postinst	1970-01-01 00:00:00 +0000
+++ debian/cron-se.postinst	2004-07-28 15:43:18 +0000
@@ -0,0 +1,21 @@
+#!/bin/sh
+set -e
+
+# Fixup crontab binary, directory and files for new group 'crontab'.
+
+if ! dpkg-statoverride --list /usr/bin/crontab > /dev/null ; then
+    chgrp crontab /usr/bin/crontab
+    chmod g+s /usr/bin/crontab
+fi
+
+if [ -x /etc/init.d/cron ]; then
+	if [ -x /usr/sbin/invoke-rc.d ] ; then
+	       invoke-rc.d cron restart
+	else
+	       /etc/init.d/cron restart
+	fi
+fi
+
+
+
+#DEBHELPER#

=== added file 'debian/cron-se.postrm'
--- debian/cron-se.postrm	1970-01-01 00:00:00 +0000
+++ debian/cron-se.postrm	2004-07-28 15:43:18 +0000
@@ -0,0 +1,20 @@
+#!/bin/sh
+set -e
+
+if [ remove = "$1" ]; then
+    dpkg-divert --package cron-se --remove --rename \
+        --divert /usr/sbin/cron.cron /usr/sbin/cron
+    dpkg-divert --package cron-se --remove --rename \
+        --divert /usr/bin/crontab.cron /usr/bin/crontab
+fi
+
+# Restart non-se cron
+if [ -x /etc/init.d/cron ]; then
+	if [ -x /usr/sbin/invoke-rc.d ] ; then
+	       invoke-rc.d cron restart
+	else
+	       /etc/init.d/cron restart
+	fi
+fi
+
+#DEBHELPER#

=== added file 'debian/cron-se.preinst'
--- debian/cron-se.preinst	1970-01-01 00:00:00 +0000
+++ debian/cron-se.preinst	2004-07-28 15:43:18 +0000
@@ -0,0 +1,11 @@
+#!/bin/sh
+set -e
+
+if [ install = "$1"  ]; then
+    dpkg-divert --package cron-se --add --rename \
+        --divert /usr/sbin/cron.cron /usr/sbin/cron
+    dpkg-divert --package cron-se --add --rename \
+        --divert /usr/bin/crontab.cron /usr/bin/crontab
+fi
+
+#DEBHELPER#

=== added file 'debian/cron-se.prerm'
--- debian/cron-se.prerm	1970-01-01 00:00:00 +0000
+++ debian/cron-se.prerm	2004-07-28 15:43:18 +0000
@@ -0,0 +1,12 @@
+#!/bin/sh
+set -e
+
+if [ -x /etc/init.d/cron ]; then
+	if [ -x /usr/sbin/invoke-rc.d ] ; then
+	       invoke-rc.d cron stop
+	else
+	       /etc/init.d/cron stop
+	fi
+fi
+
+#DEBHELPER#

=== modified file 'debian/cron.init'
--- debian/cron.init	2001-10-01 07:46:34 +0000
+++ debian/cron.init	2004-07-28 15:43:18 +0000
@@ -3,18 +3,20 @@
 
 test -f /usr/sbin/cron || exit 0
 
+#LSBNAMES='-l'  # Uncomment for LSB name support in /etc/cron.d/
+
 case "$1" in
 start)	echo -n "Starting periodic command scheduler: cron"
-        start-stop-daemon --start --quiet --exec /usr/sbin/cron
+        start-stop-daemon --start --quiet --pidfile /var/run/crond.pid --name cron --startas /usr/sbin/cron -- $LSBNAMES
         echo "." 
 	;;
 stop)	echo -n "Stopping periodic command scheduler: cron"
-        start-stop-daemon --stop --quiet --exec /usr/sbin/cron
+        start-stop-daemon --stop --quiet --pidfile /var/run/crond.pid --name cron
         echo "."
         ;;
 restart) echo -n "Restarting periodic command scheduler: cron"
-        start-stop-daemon --stop --quiet --exec /usr/sbin/cron
-        start-stop-daemon --start --quiet --exec /usr/sbin/cron
+        start-stop-daemon --stop --retry 5 --quiet --pidfile /var/run/crond.pid --name cron
+        start-stop-daemon --start --quiet --pidfile /var/run/crond.pid --name cron --startas /usr/sbin/cron -- $LSBNAMES
         echo "."
         ;;
 reload|force-reload) echo -n "Reloading configuration files for periodic command scheduler: cron"

=== modified file 'debian/cron.pam'
--- debian/cron.pam	2001-10-01 07:46:34 +0000
+++ debian/cron.pam	2004-07-28 15:43:18 +0000
@@ -2,8 +2,12 @@
 # The PAM configuration file for the cron daemon
 #
 
-account    required   pam_unix.so
-auth       required   pam_unix.so nullok
+@include common-auth
 auth       required   pam_env.so
-session    required   pam_unix.so
+@include common-account
+@include common-session
+# Sets up user limits, please uncomment and read /etc/security/limits.conf
+# to enable this functionality.
+# session    required   pam_limits.so
+
 

=== modified file 'debian/crontab.main'
--- debian/crontab.main	2001-10-01 07:46:34 +0000
+++ debian/crontab.main	2004-07-28 15:43:18 +0000
@@ -7,9 +7,10 @@
 PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
 
 # m h dom mon dow user	command
-25 6	* * *	root	test -e /usr/sbin/anacron || run-parts --report /etc/cron.daily
-47 6	* * 7	root	test -e /usr/sbin/anacron || run-parts --report /etc/cron.weekly
-52 6	1 * *	root	test -e /usr/sbin/anacron || run-parts --report /etc/cron.monthly
+17 *	* * *	root    run-parts --report /etc/cron.hourly
+25 6	* * *	root	test -x /usr/sbin/anacron || run-parts --report /etc/cron.daily
+47 6	* * 7	root	test -x /usr/sbin/anacron || run-parts --report /etc/cron.weekly
+52 6	1 * *	root	test -x /usr/sbin/anacron || run-parts --report /etc/cron.monthly
 #
 
 

=== modified file 'debian/dirs'
--- debian/dirs	2001-10-01 07:46:34 +0000
+++ debian/dirs	2004-07-28 15:43:18 +0000
@@ -3,6 +3,7 @@
 usr/share/man/man1
 usr/share/man/man5
 usr/share/man/man8
+etc/cron.hourly
 etc/cron.daily
 etc/cron.weekly
 etc/cron.monthly

=== added file 'debian/install'
--- debian/install	1970-01-01 00:00:00 +0000
+++ debian/install	2004-07-28 15:43:18 +0000
@@ -0,0 +1,2 @@
+b-cron/cron usr/sbin
+b-cron/crontab usr/bin

=== added file 'debian/placeholder'
--- debian/placeholder	1970-01-01 00:00:00 +0000
+++ debian/placeholder	2004-07-28 15:43:18 +0000
@@ -0,0 +1,2 @@
+# DO NOT EDIT OR REMOVE
+# This file is a simple placeholder to keep dpkg from removing this directory

=== modified file 'debian/postinst'
--- debian/postinst	2001-10-01 07:46:34 +0000
+++ debian/postinst	2004-07-28 15:43:18 +0000
@@ -22,17 +22,6 @@
     fi
 done
 #
-# Check for upgrades from very old versions
-#
-if [ "$1" = "configure" -a -n "$2" ] && dpkg --compare-versions "$2" lt "3.0pl1-43" ; then
-    echo " "
-    echo "The format of the setuid.today file (output from checksecurity) has"
-    echo "changed. This means that the first run of checksecurity after the "
-    echo "upgrade will produce a diff on every every file affected".
-    pausemessage="T"
-fi
-
-#
 # Move dpkg status file backups, if necessary/possible.
 #
 ( cd /var/lib/dpkg ;
@@ -46,6 +35,32 @@
     fi                        
 done)
 
-start-stop-daemon --start --quiet --oknodo --exec /usr/sbin/cron
+# Add group for crontabs
+getent group crontab > /dev/null 2>&1 || addgroup --system crontab
+
+# Fixup crontab binary, directory and files for new group 'crontab'.
+
+if ! dpkg-statoverride --list /usr/bin/crontab > /dev/null ; then
+    chgrp crontab /usr/bin/crontab
+    chmod g+s /usr/bin/crontab
+    chgrp crontab $crondir/crontabs
+    chmod 1730 $crondir/crontabs
+    if dpkg --compare-versions "$2" lt "3.0pl1-81" ; then
+        cd $crondir/crontabs
+        set +e
+        ls -1 |  xargs -r -n 1 --replace=xxx  chown 'xxx:crontab' 'xxx'
+        set -e
+    fi
+fi
+
+if [ -x /etc/init.d/cron ]; then
+	if [ -x /usr/sbin/invoke-rc.d ] ; then
+	       invoke-rc.d cron start
+	else
+	       /etc/init.d/cron start
+	fi
+fi
+
+
 
 #DEBHELPER#

=== modified file 'debian/postrm'
--- debian/postrm	2001-10-01 07:46:34 +0000
+++ debian/postrm	2004-07-28 15:43:18 +0000
@@ -5,3 +5,4 @@
     rm -f /etc/cron.allow /etc/cron.deny
 fi
 
+#DEBHELPER#

=== removed file 'debian/preinst'
--- debian/preinst	2001-10-01 07:46:34 +0000
+++ debian/preinst	1970-01-01 00:00:00 +0000
@@ -1,8 +0,0 @@
-#! /bin/sh
-#
-# Needed because -36 and -36.1 included bad prerm scripts
-#
-if [ "$1" = "upgrade" -a \( "$2" = "3.0pl1-36" -o "$2" = "3.0pl1-36.1" \) ] ; then
-   #kill the running cron
-   start-stop-daemon --oknodo --quiet --stop --exec /usr/sbin/cron
-fi

=== modified file 'debian/prerm'
--- debian/prerm	2001-10-01 07:46:34 +0000
+++ debian/prerm	2004-07-28 15:43:18 +0000
@@ -1,5 +1,12 @@
 #!/bin/sh
 set -e
-/etc/init.d/cron stop 
+
+if [ -x /etc/init.d/cron ]; then
+	if [ -x /usr/sbin/invoke-rc.d ] ; then
+	       invoke-rc.d cron stop
+	else
+	       /etc/init.d/cron stop
+	fi
+fi
 
 #DEBHELPER#

=== modified file 'debian/rules'
--- debian/rules	2001-10-01 07:46:34 +0000
+++ debian/rules	2004-07-28 15:43:18 +0000
@@ -6,18 +6,26 @@
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
 
-DEB_OPTIM= -O2 -Wall
+DEB_OPTIM= -O2 -g -Wall -Wno-comment
 DEB_INSTALL = install
 DEB_DEBUG_DEFS = -DDEBUGGING=0
 
 ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
-  DEB_OPTIM = -g -Wall 
+  DEB_OPTIM = -g -Wall -Wno-comment
   DEB_DEBUG_DEFS= -DDEBUGGING=1
 endif
 ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
   DEB_INSTALL += -s
 endif
 
+# SELinux
+ifeq (yes,$(SELINUX))
+  SELINUX_DEFS = -DWITH_SELINUX
+  SELINUX_LIBS = -lselinux
+endif
+
+export SELINUX_DEFS SELINUX_LIBS
+
 # Set system type (Linux, HURD, etc.)
 DEB_HOST_GNU_SYSTEM = $(shell dpkg-architecture -qDEB_HOST_GNU_SYSTEM)
 ifeq ($(DEB_HOST_GNU_SYSTEM), gnu)
@@ -33,22 +41,34 @@
 export PAM_DEFS
 export PAM_LIBS
 
-build: build-stamp
-build-stamp:
-	dh_testdir
-
-	# Add here commands to compile the package.
-	$(MAKE) OPTIM="$(DEB_OPTIM)" DEBUG_DEFS="$(DEB_DEBUG_DEFS)"
-
-	touch build-stamp
+
+build: build-cron build-cron-se
+
+
+build-cron: b-cron/build-stamp
+b-cron/build-stamp:
+	dh_testdir
+	rm -rf b-cron
+	mkdir b-cron
+	# Add here commands to compile the package.
+	$(MAKE) -C b-cron -f ../Makefile OPTIM="$(DEB_OPTIM)" DEBUG_DEFS="$(DEB_DEBUG_DEFS)" VPATH=.. INCLUDE=-I.. 
+	touch $@
+
+build-cron-se: b-cron-se/build-stamp
+b-cron-se/build-stamp:
+	dh_testdir
+	rm -rf b-cron-se
+	mkdir b-cron-se
+	cp debian/cron-se.overrides b-cron-se/cron-se
+	cd b-cron-se
+	# Add here commands to compile the package.
+	SELINUX_DEFS="-DWITH_SELINUX" SELINUX_LIBS=-lselinux $(MAKE) -C b-cron-se -f ../Makefile OPTIM="$(DEB_OPTIM)" DEBUG_DEFS="$(DEB_DEBUG_DEFS)" VPATH=.. INCLUDE=-I..
+	touch $@
 
 clean:
 	dh_testdir
 	dh_testroot
-	rm -f build-stamp
-
-	# Add here commands to clean up after the build process.
-	-$(MAKE) clean
+	rm -rf b-cron b-cron-se
 	rm -f debian/conffiles
 	dh_clean
 
@@ -63,11 +83,7 @@
 	dh_testroot
 	dh_clean -k
 	dh_installdirs
-
-	# Add here commands to install the files into debian/tmp
-	$(MAKE) install DESTDIR=`pwd`/debian/tmp OPTIM="$(DEB_OPTIM)" INSTALL="$(DEB_INSTALL)" DEBUG_DEFS="$(DEB_DEBUG_DEFS)"
-	install -m 755 debian/checksecurity debian/tmp/usr/sbin/.
-	install -m 644 debian/checksecurity.conf debian/tmp/etc/.
+	dh_install
 
 	cp -p debian/$(CONFFILES) debian/conffiles
 	dh_installdocs FEATURES THANKS README debian/README.anacron
@@ -78,20 +94,22 @@
 	# Can't use dh_installcron because we don't have "normal" naming
 	# convention
 	install -m 644 debian/crontab.main debian/tmp/etc/crontab
+	install -m 644 debian/placeholder debian/tmp/etc/cron.d/.placeholder
+	install -m 644 debian/placeholder debian/tmp/etc/cron.hourly/.placeholder
+	install -m 644 debian/placeholder debian/tmp/etc/cron.daily/.placeholder
+	install -m 644 debian/placeholder debian/tmp/etc/cron.weekly/.placeholder
+	install -m 644 debian/placeholder debian/tmp/etc/cron.monthly/.placeholder
 	install -m 755 debian/standard.daily \
                        debian/tmp/etc/cron.daily/standard
 	install -m 755 debian/standard.monthly \
                        debian/tmp/etc/cron.monthly/standard
-	dh_installmanpages crontab.1 crontab.5 cron.8 bitstring.3
+	dh_installman crontab.1 crontab.5 cron.8
 #	dh_undocumented
 	dh_installchangelogs CHANGES
+	dh_installdebconf
 	dh_strip
 	dh_compress
 	dh_fixperms
-	# dh_suidregister -- deliberately commented out, as it causes
-	# /usr/bin/crontab to be shipped non-suid.
-	# so does dh_fixperms when not run under fakeroot. sigh.
-	chmod u+s debian/tmp/usr/bin/crontab
 	dh_installdeb
 	dh_shlibdeps
 	dh_gencontrol

=== modified file 'debian/standard.daily'
--- debian/standard.daily	2001-10-01 07:46:34 +0000
+++ debian/standard.daily	2004-07-28 15:43:18 +0000
@@ -9,8 +9,7 @@
 umask 022
 
 #
-# Avoid running more than one at a time -- could happen if the
-# checksecurity script lands on a network drive.
+# Avoid running more than one at a time 
 #
 
 if [ -x /usr/bin/lockfile-create ] ; then
@@ -19,7 +18,7 @@
 	cat <<EOF
 
 Unable to run /etc/cron.daily/standard because lockfile $LOCKFILE
-acquisition failed. This probably means that the previous days
+acquisition failed. This probably means that the previous day's
 instance is still running. Please check and correct if necessary.
 
 EOF
@@ -39,7 +38,7 @@
 	cmp -s passwd.bak /etc/passwd || (cp -p /etc/passwd passwd.bak &&
 					  chmod 600 passwd.bak)
 	cmp -s group.bak /etc/group || (cp -p /etc/group group.bak &&
-					chmod 600 passwd.bak)
+					chmod 600 group.bak)
         if [ -f /etc/shadow ] ; then
 	  cmp -s shadow.bak /etc/shadow || (cp -p /etc/shadow shadow.bak &&
                                             chmod 600 shadow.bak)
@@ -56,16 +55,11 @@
 	    savelog -c 7 dpkg.status >/dev/null
     fi
 fi
-cd /var/log
-umask 027
-savelog -c 7 -m 640 -u root -g adm setuid.changes >/dev/null
-checksecurity >setuid.changes
-
 #
 # Check to see if any files are in lost+found directories and warn admin
 #
-# Get a list of the (potential) ext2 l+f directories
-lflist=`df -P --type=ext2  |awk '$6 == "/" {$6 = ""} /\/dev\// {printf "%s/lost+found ", $6}'`
+# Get a list of the (potential) ext2 and ext3 l+f directories
+lflist=`df -P --type=ext2 --type=ext3 |awk '$6 == "/" {$6 = ""} /\/dev\// {printf "%s/lost+found ", $6}'`
 
 # In each directory, look for files
 for lfdir in $lflist ; do

=== modified file 'do_command.c'
--- do_command.c	2001-10-01 07:46:34 +0000
+++ do_command.c	2004-07-28 15:43:18 +0000
@@ -42,10 +42,40 @@
    }
 #endif
 
+#ifdef WITH_SELINUX
+#include <selinux/selinux.h>
+/* #include <selinux/get_context_list.h> */
+#endif
+
 
 static void		child_process __P((entry *, user *)),
 			do_univ __P((user *));
 
+/* Build up the job environment from the PAM environment plus the
+   crontab environment */
+static char ** build_env(char **cronenv)
+{
+        char **jobenv = cronenv;
+#if defined(USE_PAM)
+        char **pamenv = pam_getenvlist(pamh);
+        char *cronvar;
+        int count = 0;
+
+        jobenv = env_copy(pamenv);
+
+        /* Now add the cron environment variables. Since env_set()
+           overwrites existing variables, this will let cron's
+           environment settings override pam's */
+
+        while ((cronvar = cronenv[count++])) {
+                if (!(jobenv = env_set(jobenv, cronvar))) {
+                        syslog(LOG_ERR, "Setting Cron environment variable %s failed", cronvar);
+                        return NULL;
+                }
+        }
+#endif
+    return jobenv;
+}
 
 void
 do_command(e, u)
@@ -191,6 +221,8 @@
 #if defined(USE_PAM)
 	retcode = pam_start("cron", usernm, &conv, &pamh);
 	PAM_FAIL_CHECK;
+	retcode = pam_set_item(pamh, PAM_TTY, "cron");
+	PAM_FAIL_CHECK;
 	retcode = pam_acct_mgmt(pamh, PAM_SILENT);
 	PAM_FAIL_CHECK;
 	retcode = pam_open_session(pamh, PAM_SILENT);
@@ -280,8 +312,8 @@
 		/* exec the command.
 		 */
 		{
-			char	*shell = env_get("SHELL", e->envp);
-
+                        char    **jobenv = build_env(e->envp); 
+                        char	*shell = env_get("SHELL", jobenv);
 # if DEBUGGING
 			if (DebugFlags & DTEST) {
 				fprintf(stderr,
@@ -298,7 +330,18 @@
 			}
 			fprintf(stdout,"error");
 #endif
-			execle(shell, shell, "-c", e->cmd, (char *)0, e->envp);
+#ifdef WITH_SELINUX
+			if (is_selinux_enabled() > 0) {
+                            security_context_t scontext;
+                            if (setexeccon(u->scontext) < 0) {
+                                if (security_getenforce() > 0) {
+                                    fprintf(stderr, "Could not set exec context to %s for user  %s\n", scontext,u->name);
+                                    _exit(ERROR_EXIT);
+                                }
+                            }
+			}
+#endif
+                        execle(shell, shell, "-c", e->cmd, (char *)0, jobenv);
 			fprintf(stderr, "execl: couldn't exec `%s'\n", shell);
 			perror("execl");
 			_exit(ERROR_EXIT);

=== modified file 'entry.c'
--- entry.c	2001-10-01 07:46:34 +0000
+++ entry.c	2004-07-28 15:43:18 +0000
@@ -130,12 +130,14 @@
 			bit_set(e->dom, 0);
 			bit_set(e->month, 0);
 			bit_nset(e->dow, 0, (LAST_DOW-FIRST_DOW+1));
+                        e->flags |= DOW_STAR; 
 		} else if (!strcmp("monthly", cmd)) {
 			bit_set(e->minute, 0);
 			bit_set(e->hour, 0);
 			bit_set(e->dom, 0);
 			bit_nset(e->month, 0, (LAST_MONTH-FIRST_MONTH+1));
 			bit_nset(e->dow, 0, (LAST_DOW-FIRST_DOW+1));
+                        e->flags |= DOW_STAR;
 		} else if (!strcmp("weekly", cmd)) {
 			bit_set(e->minute, 0);
 			bit_set(e->hour, 0);
@@ -463,7 +465,7 @@
 		 * sent as a 0 since there is no offset either.
 		 */
 		ch = get_number(&num3, 0, PPC_NULL, ch, file);
-		if (ch == EOF)
+		if (ch == EOF || num3 <= 0)
 			return EOF;
 	} else {
 		/* no step.  default==1.
@@ -513,6 +515,10 @@
 	}
 	*pc = '\0';
 
+        if (len == 0) {
+            return EOF;
+        }
+
 	/* try to find the name in the name list
 	 */
 	if (names) {

=== modified file 'misc.c'
--- misc.c	2001-10-01 07:46:34 +0000
+++ misc.c	2004-07-28 15:43:18 +0000
@@ -679,10 +679,21 @@
 
 
 #ifdef HAVE_SAVED_UIDS
-static int save_euid;
-int swap_uids() { save_euid = geteuid(); return seteuid(getuid()); }
-int swap_uids_back() { return seteuid(save_euid); }
+static uid_t save_euid, save_egid;
+int swap_uids()
+{
+	save_euid = geteuid(); save_egid = getegid();
+	return (setegid(getgid()) || seteuid(getuid())) ? -1 : 0;
+}
+int swap_uids_back()
+{
+	return (setegid(save_egid) || seteuid(save_euid)) ? -1 : 0;
+}
 #else /*HAVE_SAVED_UIDS*/
-int swap_uids() { return setreuid(geteuid(), getuid()); }
+int swap_uids()
+{
+	return (setregid(getegid(), getgid()) || setreuid(geteuid(), getuid()))
+		? -1 : 0;
+}
 int swap_uids_back() { return swap_uids(); }
 #endif /*HAVE_SAVED_UIDS*/

=== modified file 'user.c'
--- user.c	2001-10-01 07:46:34 +0000
+++ user.c	2004-07-28 15:43:18 +0000
@@ -23,9 +23,104 @@
  */
 
 
+#include <syslog.h>
+#include <string.h>
 #include "cron.h"
 
 
+#ifdef WITH_SELINUX
+#include <selinux/selinux.h>
+#include <selinux/flask.h>
+#include <selinux/av_permissions.h>
+#include <selinux/get_context_list.h>
+
+static int get_security_context(char *name, int crontab_fd, security_context_t
+                                *rcontext, char *tabname) {
+    security_context_t scontext;
+    security_context_t  file_context=NULL;
+    struct av_decision avd;
+    int retval=0;
+
+    rcontext = NULL;
+    if (get_default_context(name, NULL, &scontext)) {
+        if (security_getenforce() > 0) {
+            log_it(name, getpid(), "No SELinux security context", tabname);
+            return -1;
+        } else {
+            log_it(name, getpid(),
+                   "No security context but SELinux in permissive mode,"
+                   " continuing", tabname);
+        }
+    }
+
+    if (fgetfilecon(crontab_fd, &file_context) < OK) {
+        if (security_getenforce() > 0) {
+            log_it(name, getpid(), "getfilecon FAILED", tabname);
+            freecon(scontext);
+            return -1;
+        } else {
+            log_it(name, getpid(), "getfilecon FAILED but SELinux in "
+                   "permissive mode, continuing", tabname);
+            *rcontext=scontext;
+            return 0;
+        }
+    }
+
+    /*
+     * Since crontab files are not directly executed,
+     * crond must ensure that the crontab file has
+     * a context that is appropriate for the context of
+     * the user cron job.  It performs an entrypoint
+     * permission check for this purpose.
+     */
+
+    retval = security_compute_av(scontext,
+                                 file_context,
+                                 SECCLASS_FILE,
+                                 FILE__ENTRYPOINT,
+                                 &avd);
+    freecon(file_context);
+    if (retval || ((FILE__ENTRYPOINT & avd.allowed) != FILE__ENTRYPOINT)) {
+        if (security_getenforce() > 0) {
+            log_it(name, getpid(), "ENTRYPOINT FAILED", tabname);
+            freecon(scontext);
+            return -1;
+        } else {
+            log_it(name, getpid(), "ENTRYPOINT FAILED but SELinux in permissive mode, continuing", tabname);
+        }
+    }
+    *rcontext=scontext;
+    return 0;
+}
+#endif
+
+
+#ifdef DEBIAN
+/* Function used to log errors in crontabs from cron daemon. (User
+   crontabs are checked before they're accepted, but system crontabs
+   are not. */
+static char *err_user=NULL;
+
+void
+crontab_error(msg)
+     char *msg;
+{
+  const char *fn;
+  /* Figure out the file name from the username */
+  if (0 == strcmp(err_user,"*system*")) {
+    syslog(LOG_ERR|LOG_CRON,"Error: %s; while reading %s", msg, SYSCRONTAB);
+  } else if (0 == strncmp(err_user,"*system*",8)) {
+    fn = err_user+8;
+    syslog(LOG_ERR|LOG_CRON,"Error: %s; while reading %s/%s", msg, 
+	   SYSCRONDIR,fn);
+  } else {
+    syslog(LOG_ERR|LOG_CRON, "Error: %s; while reading crontab for user %s",
+	   msg, err_user);
+  }
+}
+
+#endif
+
 void
 free_user(u)
 	user	*u;
@@ -37,15 +132,20 @@
 		ne = e->next;
 		free_entry(e);
 	}
+#ifdef WITH_SELINUX
+        freecon(u->scontext);
+#endif
 	free(u);
 }
 
 
 user *
-load_user(crontab_fd, pw, name)
+load_user(crontab_fd, pw, uname, fname, tabname)
 	int		crontab_fd;
 	struct passwd	*pw;		/* NULL implies syscrontab */
-	char		*name;
+	char		*uname;
+	char		*fname;
+	char		*tabname;
 {
 	char	envstr[MAX_ENVSTR];
 	FILE	*file;
@@ -67,13 +167,29 @@
 		errno = ENOMEM;
 		return NULL;
 	}
-	if ((u->name = strdup(name)) == NULL) {
+	if ((u->name = strdup(fname)) == NULL) {
 		free(u);
 		errno = ENOMEM;
 		return NULL;
 	}
 	u->crontab = NULL;
 
+#ifdef WITH_SELINUX
+        if (is_selinux_enabled() > 0) {
+            char *sname=uname;
+            if (pw==NULL) {
+                sname="system_u";
+            }
+            if (get_security_context(sname, crontab_fd, 
+                                     &u->scontext, tabname) != 0 ) {
+                free_user(u);
+                u = NULL;
+                goto done;
+            }
+        }
+#endif
+
+
 	/* 
 	 * init environment.  this will be copied/augmented for each entry.
 	 */
@@ -93,7 +209,13 @@
 			u = NULL;
 			goto done;
 		case FALSE:
+#ifdef DEBIAN
+			err_user = fname;
+			e = load_entry(file, crontab_error, pw, envp);
+			err_user = NULL;
+#else
 			e = load_entry(file, NULL, pw, envp);
+#endif
 			if (e) {
 				e->next = u->crontab;
 				u->crontab = e;

